{% extends '@KaitekFramework/Backend/module.html.twig' %}
{% trans_default_domain (modulename) %}
{% block begin_javascript_fix %}
<script type="text/javascript">
    {% endblock begin_javascript_fix %}



    {% block begin_javascript %}
    {{ parent() }}
    {{ modulename }}Obj.prototype = {
        storeConfig:{
            Employee:{routeName:'Employee-showall',table:'employees',modulename:'Employee'}
            //,JobRotation:{routeName:'JobRotation-getComboValues',table:'job_rotations'}
            //,JobRotationG:{routeName:'JobRotation-getComboValues',table:'job_rotations'}
            //,JobRotationTeam:{routeName:'JobRotationTeam-getComboValues',table:'job_rotation_teams'}
            //,JobRotationTeamG:{routeName:'JobRotationTeam-getComboValues',table:'job_rotation_teams'}
        },
        init : function(){
            var t = this;
            {{ modulename }}Obj.superclass.init.call(t);
            t.windowButtons.edit=false;
            t.checks = {};
            const gridConfig = {
                //selectMode:'cell',
                cm: [
                    //{header: "", dataIndex: 'del', width: 30,renderer:mj.renderer.check()},
                    {header: "{{ 'JobRotationEmployee.week'|trans }}", dataIndex: 'week', width: 50,filter:'between',alias:'jre',align:'right'},
                    {header: "{{ 'JobRotationEmployee.day'|trans }}", dataIndex: 'day', width: 70,filter:'between',alias:'jre'},
                    {header: "{{ 'JobRotationEmployee.jobrotation'|trans }}", dataIndex: 'jobrotation', width: 70,filter:'single',type:'combo',store:t.extras.job_rotations,alias:'jre',operator:'='},
                    {header: "{{ 'JobRotationEmployee.jobrotationteam'|trans }}", dataIndex: 'jobrotationteam', width: 150,filter:'single', type:'combo',store:t.extras.job_rotation_teams,alias:'jre',operator:'='},
                    {header: "{{ 'JobRotationEmployee.code'|trans }}", dataIndex: 'code', width: 60,filter:'between',alias:'e'},
                    {header: "{{ 'JobRotationEmployee.employee'|trans }}", dataIndex: 'name', width: 120,filter:'single',alias:'e',operator:'%.%'},
                    {header: "{{ 'JobRotationEmployee.isovertime'|trans }}", dataIndex: 'isovertime', width: 70,renderer:mj.renderer.check(),filter:'single', type:'check',alias:'jre'},
                    {header: "{{ 'JobRotationEmployee.beginval'|trans }}", dataIndex: 'beginval', width: 60,alias:'jre'},
                    {header: "{{ 'JobRotationEmployee.endval'|trans }}", dataIndex: 'endval', width: 60,alias:'jre'},
                    {header: "{{ 'JobRotationEmployee.worktime'|trans }}", dataIndex: 'worktime', width: 70,alias:'jre'},
                    {header: "{{ 'JobRotationEmployee.breaktime'|trans }}", dataIndex: 'breaktime', width: 70,alias:'jre'}
                ]
            };

            t._setGridConfig(gridConfig);

            const formConfig= {
                items: [
                    new mj.form.fieldSet({
                        id : 'f1',
                        title : '&nbsp;',
                        labelWidth : '110px',
                        width : 300,
                        height : 320,
                        items : [
                            new mj.form.field({
                                dataIndex: 'id',
                                hidden: true
                            }),
                            new mj.form.field({
                                dataIndex: 'version',
                                hidden: true
                            }),
                            new mj.form.dateField({
                                title : "{{ 'JobRotationEmployee.date'|trans }}",
                                labelWidth : '110px',
                                dataIndex : 'dateStart',
                                width : 80,
                                notEmpty : true
                            }),
                            new mj.form.dateField({
                                title : ' - ',
                                labelWidth : '10px',
                                dataIndex : 'dateEnd',
                                width : 80,
                                right : true,
                                notEmpty : true
                            }),
                            new mj.form.numberField({
                                title: "{{ 'JobRotationEmployee.week'|trans }}",
                                dataIndex: 'week',
                                maxLength: 2,
                                notEmpty: true,
                                labelWidth : '110px',
                                grid: 's12 m6',
                                width:20
                            }),
                            new mj.form.combo({
                                title: "{{ 'JobRotationEmployee.jobrotation'|trans }}",
                                placeHolder: "{{ 'JobRotationEmployee.jobrotation_placeholder'|trans }}",
                                dataIndex: 'jobrotation',
                                mode: 'local',
                                clearOnTriggerClick: true,
                                labelWidth : '110px',
                                grid: 's6 m4',
                                store: t.extras.job_rotations
                            }),
                            new mj.form.combo({
                                title: "{{ 'JobRotationEmployee.jobrotationteam'|trans }}",
                                placeHolder: "{{ 'JobRotationEmployee.jobrotationteam_placeholder'|trans }}",
                                dataIndex: 'jobrotationteam',
                                mode: 'local',
                                clearOnTriggerClick: true,
                                labelWidth : '110px',
                                grid: 's6 m4',
                                store: t.extras.job_rotation_teams
                            }),
                            new mj.form.checkBox({
                                title: "{{ 'JobRotationEmployee.isovertime'|trans }}",
                                id: 'isovertime',
                                dataIndex: 'isovertime',
                                itemStyle: 'padding:0 35px 0 0;float:left;',
                                labelWidth : '110px',
                                grid: 'none'
                            }),
                            new mj.form.timeField({
                                title: "{{ 'JobRotationEmployee.beginval'|trans }}",
                                dataIndex: 'beginval',
                                labelWidth : '110px',
                                notEmpty: true,
                                grid: 's4 m2',
                                width:40
                            }),
                            new mj.form.timeField({
                                title: "{{ 'JobRotationEmployee.endval'|trans }}",
                                dataIndex: 'endval',
                                labelWidth : '110px',
                                grid: 's4 m2',
                                width:40
                            }),
                            new mj.form.numberField({
                                title: "{{ 'JobRotationEmployee.worktime'|trans }}",
                                dataIndex: 'worktime',
                                maxLength: 3,
                                notEmpty: true,
                                labelWidth : '110px',
                                grid: 's12 m6',
                                width:40
                            }),
                            new mj.form.numberField({
                                title: "{{ 'JobRotationEmployee.breaktime'|trans }}",
                                dataIndex: 'breaktime',
                                maxLength: 3,
                                notEmpty: true,
                                labelWidth : '110px',
                                grid: 's12 m6',
                                width:40
                            })
                        ]
                    }),
                    new mj.form.fieldSet({
                        id : 'f2',
                        title : '&nbsp;',
                        labelWidth : '110px',
                        width : 500,
                        height : 320,
                        style : 'position:absolute;top:0px;left:340px;'
                    })
                ]
            };

            t._setFormConfig(formConfig,t.initFormElementsEvents);

            t.buttons.selectNone = t.forms.main.addButton({
                alt: "{{ 'JobRotationEmployee.selectNone'|trans }}",
                cls: 'btn-sm left',
                iconCls: 'mj-checkbox',
                scope: t,
                handler: function(){
                    t.checker(0);
                }
            });
            t.buttons.selectAll = t.forms.main.addButton({
                alt: "{{ 'JobRotationEmployee.selectAll'|trans }}",
                cls: 'btn-sm left',
                iconCls: 'mj-checkbox-checked',
                scope: t,
                handler: function(){
                    t.checker(1);
                }
            });

            t.cmb_vardiya=t.forms.main.items[7];
            t.cmb_vardiyaekip=t.forms.main.items[8];
            t.beginval=t.forms.main.items[10];
            t.endval=t.forms.main.items[11];
            t.len=t.forms.main.items.length;
            t.cmb_vardiya.on('triggerclick',function(){
                t.beginval.setValue('');
                t.endval.setValue('');
            });

            t.cmb_vardiya.view.on('itemclick',function(){
                var arr_val=this.selected[0].value.split('-');
                t.beginval.setValue(arr_val[0]);
                var arr_endval=arr_val[1].split(':');
                arr_endval[1]=arr_endval[1]=="00"?"59":"29";
                t.endval.setValue(arr_endval.join(':'));
            });

            t.stores.Employee.on('load',function(st){
                t.clearPersonel();
                for(var i = 0,l = st.data.length;i<l;i++){
                    if(t.forms.main.items.getIndex('id','employee_' + st.data[i].code) === -1){
                        t.forms.main.add(
                            new mj.form.checkBox({
                                title : st.data[i].name,
                                id : 'employee_' + st.data[i].code,
                                labelWidth : '370px',
                                labelPos : 'right',
                                dataIndex : 'employee'/*,
                                checked : st.data[i].checked*/
                            }),'f2'
                        );
                    }
                }
                t.checks.employee = t.forms.main.items[1].items;
            },t);

            t.cmb_vardiyaekip.on('triggerclick',function(){
                t.clearPersonel();
            });

            t.cmb_vardiyaekip.view.on('itemclick',function(){
                var val=this.selected[0].value;
                var routeName='Employee-showall';
                var route = Routing.getRoute(routeName);
                var data = {
                    'menuId': t.id,
                    'pg': 1,
                    'lm': 10000,
                    'filters' : [{alias:"e",fieldname:"isoperator",operator:"=",value:true}
                            ,{alias:"e",fieldname:"jobrotationteam",operator:"=",value:val}]
                };
                t.stores.Employee.url=Routing.generate(routeName, data);
                t.stores.Employee.load();
            });

            //t.grids.main.on('cellclick',function(g,ri,ci,ce){
            //    t.grids.main.selectedRow.data = t.grids.main.store.data[ri];
            //    t.cellcheck(ri,ci,-1);
            //    t._onMainGridRowClick(g, ri);
            //});
        },
        //cellcheck:function(ri,ci,v){
        //    var t=this;
        //    //console.log('ri:'+ri+' ci:'+ci+' v:'+v);
        //    var d = t.grids.main.selectedRow.data;
        //    if(ci==1){
        //        if(d.del===1){
        //            t.grids.main.setCellValue(ri,0,0,mj.renderer.check(),true);
        //        }else {
        //            t.grids.main.setCellValue(ri,0,1,mj.renderer.check(),true);
        //        }
        //    }
        //},
        checker : function(v){
            var t=this;
            var bi = t.forms.main.items[1].items;
            for(var i=0;i<bi.length;i++){
                bi[i].setValue(v);
            }
        },
        clearPersonel : function(){
            var t=this;
            t.checks = {};
            t.forms.main.items[1].innerEl[0].innerHTML="";
            t.forms.main.items[1].items=[];
            while(t.forms.main.items.length>t.len){
                delete t.forms.main.cachedItems[t.forms.main.items[t.forms.main.items.length-1].id];
                t.forms.main.items[t.forms.main.items.length-1].destroy();
                t.forms.main.items.remove(t.forms.main.items[t.forms.main.items.length-1]);
            }
        },
        editSelectedRecord: function(){
            return;
        },
        save: function() {
            var t = this,
                _f = this.forms,
                f = this.forms.main;
            t.trigger('beforesave');
            delete f.cachedItems['employee'];
            if (f.modulename && typeof Routing !== 'undefined') {
                //if (f.validate()) {
                    var employees="";
                    var flag=false;
                    for(var i = 0 , l = t.checks.employee.length;i<l;i++){
                            if(t.checks.employee[i].checked){
                                flag=true;
                                id = t.checks.employee[i].id.replace('employee_','');
                                employees=(employees==""?id:employees+","+id);
                            }
                    }
                    if(flag){
                        t.waitMaskShow();
                        var id = f.getValue('id').id;
                        var versionField = f.getField('version');
                        var version = typeof versionField != "undefined" ? f.getValue('version').version : 0;
                        var mode = id ? 'update' : 'add';
                        var routeName = f.modulename + '-' + mode;
                        var route = Routing.getRoute(routeName);
                        var pagerParams = (t.grids && t.grids.main && t.grids.main.pbar) ? {
                            'pg': t.grids.main.pbar.current,
                            'lm': t.grids.main.pbar.limit
                        } : {};
                        var url = Routing.generate(routeName, id ? mj.apply(pagerParams, {
                            'id': id,
                            'v': version
                        }) : pagerParams);
                        var data = f.getValue();
                        data.employees=employees;
                        data.menuId = t.id;
                        if (route && route.methods && route.methods.length>0 && route.methods[0]) {
                            t.waitMaskShow();
                            t._event='save';
                            $.ajax({
                                url: url,
                                method: "POST",
                                headers: { 
                                    "Content-Type": "application/json",
                                    "X-HTTP-Method-Override": route.methods[0] 
                                },
                                data: JSON.stringify(data),
                                dataType: 'json',
                                success: function(data, textStatus, jqXHR) {
                                    t.clearPersonel();
                                    t.reset(_f, data);
                                    //t.activateTabGrid();
                                    //t.waitMaskHide();
                                },
                                error: function(jqXHR, textStatus, errorThrown) {
                                    t.waitMaskHide();
                                    mj.message({
                                        title: mj.lng.glb.error,
                                        msg: jqXHR.responseJSON.message + "<br>" + jqXHR.responseJSON.file,
                                        type: "error",
                                        html: true
                                    });
                                },
                                complete: function(jqXHR, textStatus) {
                                    //t.waitMaskHide();
                                }
                            });
                        }
                    }else{
                        t.messageShow(t,mj.lng.glb.error,mj.lng.glb.formSaveWarning);
                    }
                //}
            }
        }
    };
    {% endblock begin_javascript %}



    {% block begin_default_module %}
    {{ parent() }}
    {% endblock begin_default_module %}



    {% block end_default_module %}
    {{ parent() }}
    {% endblock end_default_module %}


    {% block end_javascript %}
    {{ parent() }}
    {% endblock end_javascript %}


    {% block end_javascript_fix %}
</script>
{% endblock end_javascript_fix %}



{% block body %}
    {{ parent() }}
{% endblock body %}
